import 'dart:convert';

enum ExceptionCode {
  badRequest,
  invalidInput,
  unathorized,
  internal,
  credentialsExpired,
  forbbiden
}

class AppException implements Exception {
  AppException(this.message, [this.code = ExceptionCode.internal]);

  String message;
  ExceptionCode code = ExceptionCode.internal;

  factory AppException.fromJson(String json) {
    var map = jsonDecode(json);
    var message =
        map["message"] ?? (map["errors"]).toString() ?? "Erro desconhecido";
    var code = map["code"] ?? ExceptionCode.internal.index;
    return AppException(message, ExceptionCode.values[code]);
  }

  @override
  String toString() {
    return message;
  }
}
